/*--------------------------------
 * 
 * Jerome.Gouzy@toulouse.inra.fr
 * Created: 20140407
 * 
 * $Id: sequenceset.h 463 2015-11-13 04:03:01Z gouzy $
 * 
 ---------------------------------*/



#ifndef SEQUENCESET_H

#define SEQUENCESET_H

#define PAIRS    0
#define OBSOLETE 1
#define LR       2
#define VLR      3
#define VLR_CAND 4

#include "general.h"
#include "utarray.h"

typedef unsigned int seqid_t;


typedef struct sequenceset
{
	char *sequence;
//	float qualscore; 		// moyenne des occurences de kmer
	char status;            // 0 paire ok, 1 paire obsolete, 2 lr failed (=redo ovh 0), 3 kmer composition problematique, 4 redundant, 5 vlr cand
	char *lr;
//	UT_array *a_links; // je pense que je ne l'utile pas dans boost-r, ca coute ne RAM ==> a virer ?
} sequenceset_t;

typedef struct linkcov
{
	seqid_t link;
	short   cov;
} linkcov_t;

int   MallocSeqSet(sequenceset_t ***seqset, seqid_t nb_max_seq);
void  DeleteSequenceSet(sequenceset_t ***seqset,seqid_t nb_max_seq,int obsolete_only);
char  *GetSeq(sequenceset_t **seqset,seqid_t id);
char  *GetSeqLR(sequenceset_t **seqset,seqid_t id);
void  SetSeq(sequenceset_t **seqset,seqid_t id,char *seq);
void  SetSeqLR(sequenceset_t **seqset,seqid_t id,char *seq);
void  DelSeq(sequenceset_t **seqset,seqid_t id,int partial);
void  DelSeqLR(sequenceset_t **seqset,seqid_t id);
void  DelSeqHub(sequenceset_t **seqset,seqid_t id,int what);
char *GetSeqHub(sequenceset_t **seqset,seqid_t id,int what);
void  SetQual(sequenceset_t **seqset,seqid_t id,float qualscore);
//int 	MoveSeq(sequenceset_t **seqset_src,sequenceset_t **seqset_dst,seqid_t id);
int   SeqSortByLen(sequenceset_t *a,sequenceset_t *b);
void  LowerCase(sequenceset_t **seqset,seqid_t id,int start,int end,char strand,int what);
static void	LowerCaseSeq(char *seq,int lstart,int lend);
inline void	LowerCaseSeq(char *seq,int lstart,int lend)
{
	if ( seq != NULL )
	{
		int delta_code = 'a'-'A';
		int i;
		for(i=lstart-1;i<=(lend-1);i++)
			if ( seq[i] <= 'T' ) // ATCG butnot atcg
				*(seq+i) += delta_code;
	}
}

seqid_t GetSequenceSetCount(sequenceset_t** seqset, seqid_t nb_max_seq,int what);
int SetSeqStatus(sequenceset_t **seqset,seqid_t id,char status);

void DelSeqLinks(sequenceset_t**seqset, seqid_t nb_max_seq);


#endif
