/*--------------------------------
 * 
 * Jerome.Gouzy@toulouse.inra.fr
 * Created: 20160714
 * 
 * $Id: til-r.c 539 2017-08-18 15:05:10Z gouzy $
 * 
 ---------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include "til-r.h"
#define  PCI100_DELTA  10

UT_icd ovlwith_t_icd = {sizeof(ovlwith_t), NULL, NULL, NULL };
UT_icd region_t_icd  = {sizeof(region_t), NULL, NULL, NULL };

// il y a une faille dans l'utilisation des contains de falcon pour la detection des repeats car les ovl inclus forcement l'une des deux sequence

// dans la validation il ne faudrait pas prendre comme best|validateur une lecture qui n'apporte pas au moins minwing 

int main(int argc,char *argv[])
{
	pid_t pid = getpid();
	char tmpstr[MAXLINE];
	tmpstr[0]='\0';
	paramparser_t *o_param=NULL;
	unsigned long long max_mem_usage=0;
	
	char auth[500]="";
	char rev[500];
	sprintf(rev,"$Rev: 539 $ Compiled on %s at %s, AUTH=%zu GCC=%d.%d.%d\n", __DATE__, __TIME__,strlen(auth),__GNUC__,__GNUC_MINOR__,__GNUC_PATCHLEVEL__);
/* not used	fprintf(stderr,"libpthread: Copyright (c) 2002-2013 Free Software Foundation, Inc. http://www.gnu.org/licenses/\n"); */
	ParamParserPrintCli(argc,argv,stderr,rev);
	
	if ( argc == 1 )
	{
		Usage(argv);
		exit(0);
	}
	
//	SetStackSize(100000);
	
	char param_str[BUFFER_SIZE] = "help src=s ovlin=s ovlout=s ncpus=i minwing=i minseedendcov=i minovl=i minpci=s minseqlen=i deltapci=s penalty_fact=s specificregions=s spemode=i dump-wings dump-postspe only-rbh dump-nocont genomesize=s slicex=s";
	ParamParserInit(&o_param,argc,argv,param_str);
	ParamParserSetUnlessDefined(&o_param,"ncpus",itoa(DEFAULT_PARAM_NCPUS,tmpstr));
	ParamParserSetUnlessDefined(&o_param,"minwing",itoa(DEFAULT_PARAM_MINWING,tmpstr));
	ParamParserSetUnlessDefined(&o_param,"minseedendcov",itoa(DEFAULT_PARAM_MINSEEDENDCOV,tmpstr));
	ParamParserSetUnlessDefined(&o_param,"minovl",itoa(DEFAULT_PARAM_MINOVL,tmpstr));
	ParamParserSetUnlessDefined(&o_param,"spemode",itoa(DEFAULT_PARAM_SPEMODE,tmpstr));
	ParamParserSetUnlessDefined(&o_param,"minpci",ftoa(DEFAULT_PARAM_MINPCI,tmpstr));
	ParamParserSetUnlessDefined(&o_param,"minseqlen",ftoa(DEFAULT_PARAM_MINSEQLEN,tmpstr));
	ParamParserSetUnlessDefined(&o_param,"deltapci",ftoa(DEFAULT_PARAM_DELTAPCI,tmpstr));
	ParamParserSetUnlessDefined(&o_param,"slicex",ftoa(DEFAULT_PARAM_SLICEX,tmpstr));
	/*
	ParamParserSetUnlessDefined(&o_param,"penalty_fact",ftoa(DEFAULT_PARAM_PENALTYFACT,tmpstr));
	lof_t lof;
	ParamParserInitLof(lof);
	ParamParserGetListOfFiles(&o_param,"lof",lof);
	float penalty_fact = atof(ParamParserGet(&o_param,"penalty_fact"));
	*/
	int minwing   = atoi(ParamParserGet(&o_param,"minwing"));
	int minseqlen = atoi(ParamParserGet(&o_param,"minseqlen"));
	int spemode   = atoi(ParamParserGet(&o_param,"spemode"));
	float minpci  = atof(ParamParserGet(&o_param,"minpci"));
	float deltapci = atof(ParamParserGet(&o_param,"deltapci"));
	int minovl = atoi(ParamParserGet(&o_param,"minovl"));
	double meancov = 0;
	int maxcov = 0;
	int nbseqok=0;
	
	ParamParserAssertFileExists(&o_param,"src");
	ParamParserAssertFileExists(&o_param,"ovlin");
	ParamParserAssertDefined(&o_param,"ovlout");
	unsigned long long genomesize=0;
	
	if( ParamParserIsDefined(&o_param,"specificregions") )
	{	
		ParamParserAssertFileExists(&o_param,"specificregions");
		fprintf(stderr,"Note: specific/anchor regions will be loaded from file (%s)\n",ParamParserGet(&o_param,"specificregions"));
	}
	else if ( ParamParserIsDefined(&o_param,"genomesize") )
	{
		char buffsize[BUFFER_SIZE];
		sprintf(buffsize,"%s",ParamParserGet(&o_param,"genomesize"));
		genomesize=GetGenomeSize(buffsize);
		fprintf(stderr,"Note: specific/anchor regions will be cumputed (genomesize = %lld bp)\n",genomesize);
	}
	else
	{
		fprintf(stderr,"Warning: no specific/anchor regions provided/computed\n");
	}
	
	seqsortportance_t *a_seqportance=NULL;
	int ncpus = (int) atoi(ParamParserGet(&o_param,"ncpus"));
	int minseedendcov = (int) atoi(ParamParserGet(&o_param,"minseedendcov"));
	char *param_filename_src = ParamParserGet(&o_param,"src");
	char ovlin[BUFFER_SIZE];
	char ovlin_full[BUFFER_SIZE];
	char ovlout[BUFFER_SIZE];
	sprintf(ovlin,"%s",ParamParserGet(&o_param,"ovlin"));
	sprintf(ovlin_full,"%s",ParamParserGet(&o_param,"ovlin")); 
	
	Date("til-r: step 0, Init from fastafile (FALCON formatted)");
	
	sequence_t *a_src=NULL;
	unsigned long long nb_seq=0;
	int maxlen_src=0;
	LoadFastafile(&a_src,param_filename_src,&nb_seq,TRUE);
	
	unsigned long long i,j;
	// je commence par identifier l'identifiant max (id = integer dans falcon)
	char id[250];
	unsigned int maxid=0;
	int curr=0;
	for(i=0;i<nb_seq;i++)
	{
		sscanf(&a_src[i].header[1],"%d",&curr);
		if (curr>maxid)
			maxid=curr;
	}
	fprintf(stderr,"max=%d\n",maxid);
	
	InitMaxMemUsage(&max_mem_usage);
	fprintf(stderr,"Sequence loading ............. done, max memory = %d Mb\n",(int)max_mem_usage/1024);
	
	seq_t *a_seq            = (seq_t *)malloc((maxid+1)*sizeof(seq_t));
	
	// liste des regions specifiques de chaque sequence
	UT_array** a_spe_regions=(UT_array **)malloc(sizeof(UT_array *)*(maxid+1));
	
	InitDataStruct(&a_seq,a_spe_regions,maxid,1);

	
	int speregionsloaded=FALSE;
	if( ParamParserIsDefined(&o_param,"specificregions") )
	{
		sprintf(ovlout,"%s",ParamParserGet(&o_param,"specificregions"));
		LoadAnchorRegions(ovlout,a_spe_regions);
		speregionsloaded=ANCHOR_LOADED;
	}
	else if ( ParamParserIsDefined(&o_param,"genomesize") )
	{
		fprintf(stderr,"Computing specific regions ..... started\n");
		sprintf(ovlout,"%s.%d.specificregions.bed",ParamParserGet(&o_param,"ovlout"),getpid());
		float slicex= (float) atof(ParamParserGet(&o_param,"slicex"));
		ComputeAnchorRegions(&a_src,nb_seq,&a_seq,maxid,a_spe_regions,genomesize,ovlin,slicex);
	    DumpAnchorRegions(ovlout,a_spe_regions,maxid);
		fprintf(stderr,"Computing specific regions ..... done\n");
		speregionsloaded=ANCHOR_LOADED;
	}
	if ( speregionsloaded )
	{
		InitMaxMemUsage(&max_mem_usage);
		fprintf(stderr,"Loading specific regions ..... done, max memory = %d Mb\n",(int)max_mem_usage/1024);
	}
	
	LoadOverlaps(ovlin,&a_seq,minpci,minovl,minseqlen,a_spe_regions,speregionsloaded,spemode);
	
	InitMaxMemUsage(&max_mem_usage);
	fprintf(stderr,"Overlap loading .............. done, max memory = %d Mb\n",(int)max_mem_usage/1024);
	
	if( ParamParserIsDefined(&o_param,"specificregions") && ParamParserIsDefined(&o_param,"dump-postspe") )
	{
		sprintf(ovlout,"%s.01.postloading.ovl",ParamParserGet(&o_param,"ovlout"));
		DumpOverlaps(ovlin,&a_seq,ovlout,minpci,minovl,deltapci,ALL_OVL);
		strcpy(ovlin,ovlout); // pour accelerer
	}
	
	if ( ParamParserIsDefined(&o_param,"only-rbh")  )
	{
		CleanupNoReciprocal(&a_seq,maxid);
		sprintf(ovlout,"%s.02.reciprocal.ovl",ParamParserGet(&o_param,"ovlout"));
		DumpOverlaps(ovlin,&a_seq,ovlout,minpci,minovl,deltapci,ALL_OVL);
		exit(0);
	}
	
	if ( (100.0-deltapci) > minpci ) // sinon cela ne sert a rien
		CleanupBasedOnIdentity(&a_seq,maxid,minpci,deltapci);
	else
		fprintf(stderr,"Warning: no filtering based on identity percentage\n");
	
	//
	// nettoyage des hits multiples (meme orientation puis orientation !=) 
	//
	TagRedundantOverlaps(&a_seq,maxid); // plusieurs hits entre deux sequences sur la meme extremite
	RemoveDoubleLinked(&a_seq,maxid);   // si plusieurs hits avec la meme sequence sur les deux extremite, on garde le plus long, pas de suppression de sequences
	
	// Calcul de couverture
	GetMeanCov(&a_seq,maxid,&meancov,&maxcov,TRUE);
	
	//
	// Traitement des wings
	// (obligatoire car c'est ici que les lectures sont mises a ST_KEEP)
	//
	// Calcul des 3,5' wings 
	InitWings(&a_seq,maxid,minwing); // Max(Min(ovllen,wing),wing[35])
	// Edit/Elimination des sequences dont les 2 extremites n'apportent pas d'info
	// je le fais de facon iterative car la suppression entraine un recalcul des wings InitWings
	IterativeCheckOfWings(&a_seq,maxid,minwing);
	
	// a ce stade, toutes les sequences ont au moins un overlap et une wing qui atteignent minwing, et ce des deux cotes
	
	nbseqok = CompressListOfOverlaps(&a_seq,maxid,FALSE); // j'ai supprime bcp de sequences, je vais comprimer les listes (len=0) pour parcourir plus vite et pour avoir le nombre exact de voisins
	
	if( ParamParserIsDefined(&o_param,"dump-wings") )
	{
		char ovlwing[BUFFER_SIZE];
		sprintf(ovlwing,"%s.03.wings.ovl",ParamParserGet(&o_param,"ovlout"));
		DumpOverlaps(ovlin,&a_seq,ovlwing,minpci,minovl,deltapci,ALL_OVL);
		strcpy(ovlin,ovlout); // pour accelerer
	}
	
	GetMeanCov(&a_seq,maxid,&meancov,&maxcov,TRUE);
	
	RemoveContained(ovlin_full,&a_seq,maxid,minwing);
	CleanupNoReciprocal(&a_seq,maxid);
	GetMeanCov(&a_seq,maxid,&meancov,&maxcov,TRUE);
	if( ParamParserIsDefined(&o_param,"dump-nocont") )
	{
		sprintf(ovlout,"%s.04.nocontained.ovl",ParamParserGet(&o_param,"ovlout"));
		DumpOverlaps(ovlin,&a_seq,ovlout,minpci,minovl,deltapci,ALL_OVL);
		strcpy(ovlin,ovlout); // pour accelerer
	}
	
	// la portance c'est la longeur de la lecture plus les ailes
	// je l'utilise juste pour traiter les sequences dans un ordre inverse de portance (ca n'a pas d'importance s'il n'y a pas de selection)
	nbseqok = CompressListOfOverlaps(&a_seq,maxid,FALSE); // j'ai supprime bcp de sequences, je vais comprimer les listes (len=0) pour parcourir plus vite et pour avoir le nombre exact de voisins
	InitPortance(&a_seqportance,nbseqok,&a_seq,maxid);
	ValidateOverlaps(&a_seq,maxid,&a_seqportance,nbseqok);
	CleanupNoReciprocal(&a_seq,maxid);
	GetMeanCov(&a_seq,maxid,&meancov,&maxcov,TRUE);
	sprintf(ovlout,"%s.05.validated.ovl",ParamParserGet(&o_param,"ovlout"));
	DumpOverlaps(ovlin,&a_seq,ovlout,minpci,minovl,deltapci,ALL_OVL);

	InitMaxMemUsage(&max_mem_usage);
	fprintf(stderr,"Exit .............................., max memory = %d Mb\n",(int)max_mem_usage/1024);
	exit(0);
}

void InitDataStruct(seq_t **a_seq,UT_array** a_spe_regions,unsigned int maxid,int mode)
{
unsigned int i;

	for(i=0;i<(maxid+1);i++)
	{
		(*a_seq+i)->len=0;
		if ( mode )
		{
			utarray_new((*a_seq+i)->ovl3,&ovlwith_t_icd);
			utarray_new((*a_seq+i)->ovl5,&ovlwith_t_icd);
		}
		else
		{
			utarray_clear((*a_seq+i)->ovl3);
			utarray_clear((*a_seq+i)->ovl5);
		}
		(*a_seq+i)->maxwing3=0;
		(*a_seq+i)->maxwing5=0;
		(*a_seq+i)->maxpci3=0;
		(*a_seq+i)->maxpci5=0;
		(*a_seq+i)->contig=0;
		(*a_seq+i)->slice_id=-1;
		(*a_seq+i)->status=ST_INIT;
		
		//init des regions specificiques
		if ( mode )
			utarray_new(a_spe_regions[i],&region_t_icd);
	}
}

unsigned long long GetGenomeSize(char *buffsize)
{
unsigned long long genomesize=0;
double fact=1.0;
char *last=&buffsize[strlen(buffsize)-1];
double gs=0;

	if ( *last == 'G' || *last == 'g' )
		fact=1000000000.0;
	else if ( *last == 'M' || *last == 'm' )
		fact=1000000.0;
	else if ( *last == 'K' || *last == 'k' )
		fact=1000.0;
	if ( fact > 1 )
		*last='\0';
	gs = atof(buffsize);
	genomesize = (unsigned long long) (gs * fact);
	return genomesize;
}

// ============ GRAPH CLEANING ===============

/*
// A -----------
// B       ---------
// C    ----------     << C validate B<->A
// prerequis: hit reciproques
void CleanupNotConfirmed(seq_t **a_seq,int maxid)
{
unsigned long long i;
seq_t *p_seq;
seq_t *p_seq2;
ovlwith_t *p_ovl;
ovlwith_t *p_ovl2;
int found;

	Date("CleanupNotConfirmed");
	for(i=0;i<maxid;i++)
	{
		p_seq = (*a_seq+i);
		if ( p_seq->len == 0 )
			continue;
		if( p_seq->status == ST_AVOID )
			continue;
		
		for(p_ovl=(ovlwith_t*)utarray_front(p_seq->ovl3); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(p_seq->ovl3,p_ovl)) // A
		{
			p_seq2=(*a_seq+p_ovl->seqid); // B
			found=0;
			for(p_ovl2=(ovlwith_t*)utarray_front(p_seq2->ovl3); p_ovl2!=NULL && ! found; p_ovl2=(ovlwith_t*)utarray_next(p_seq2->ovl3,p_ovl2))  // C=voisins de B
				found=IsReciprocal(p_seq,p_ovl2->seqid); // je regarde si je trouve dans la liste des voisins de A, le C
			for(p_ovl2=(ovlwith_t*)utarray_front(p_seq2->ovl5); p_ovl2!=NULL && ! found; p_ovl2=(ovlwith_t*)utarray_next(p_seq2->ovl5,p_ovl2))
				found=IsReciprocal(p_seq,p_ovl2->seqid);
				
			if ( ! found )
			{
				//fprintf(stderr,"3: %lld <=> %d not confirmed\n",i,p_ovl->seqid);
				p_ovl->len=0;
				p_ovl->selected=0;
			}
		}
		for(p_ovl=(ovlwith_t*)utarray_front(p_seq->ovl5); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(p_seq->ovl5,p_ovl)) 
		{
			p_seq2=(*a_seq+p_ovl->seqid); // B
			found=0;
			for(p_ovl2=(ovlwith_t*)utarray_front(p_seq2->ovl3); p_ovl2!=NULL && ! found; p_ovl2=(ovlwith_t*)utarray_next(p_seq2->ovl3,p_ovl2))  // C=voisins de B
				found=IsReciprocal(p_seq,p_ovl2->seqid); // je regarde si je trouve dans la liste des voisins de A, le C
			for(p_ovl2=(ovlwith_t*)utarray_front(p_seq2->ovl5); p_ovl2!=NULL && ! found; p_ovl2=(ovlwith_t*)utarray_next(p_seq2->ovl5,p_ovl2))
				found=IsReciprocal(p_seq,p_ovl2->seqid);
				
			if ( ! found )
			{
				//fprintf(stderr,"5: %lld <=> %d not confirmed\n",i,p_ovl->seqid);
				p_ovl->len=0;
				p_ovl->selected=0;
			}
		}
	}
	CompressListOfOverlaps(a_seq,maxid,TRUE);
}
*/



// la longueur des ovl qui ne sont pas dans la gamme d'identite est mise a 0 (cote query ET target)
void CleanupBasedOnIdentity(seq_t **a_seq,int maxid,float minpci, float deltapcif)
{
unsigned long long i;
seq_t *p_seq;
short deltapci=(short)(deltapcif*100);

	Date("CleanupBasedOnIdentity");
	for(i=0;i<maxid;i++)
	{
		p_seq = (*a_seq+i);
		if ( p_seq->len == 0 )
			continue;
		if( p_seq->status == ST_AVOID )
			continue;
		
		CleanupBasedOnIdentityOneEnd(a_seq,p_seq->ovl3,p_seq->maxpci3,deltapci,i);
		CleanupBasedOnIdentityOneEnd(a_seq,p_seq->ovl5,p_seq->maxpci5,deltapci,i);
	}
	CompressListOfOverlaps(a_seq,maxid,FALSE);
}

void CleanupBasedOnIdentityOneEnd(seq_t **a_seq,UT_array *ovl,short int maxpci,short deltapci,unsigned long long seqid)
{
ovlwith_t *p_ovl;

	short tolerence=(maxpci-deltapci); // depend de l'extremite
	for(p_ovl=(ovlwith_t*)utarray_front(ovl); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(ovl,p_ovl)) 
	{	
		if ( p_ovl->len > 0 && p_ovl->pci < tolerence ) // le courant n'est pas, deja elimine, dans la gamme
		{
			if ( ! CheckReciprocalIdentity((*a_seq+p_ovl->seqid),seqid,p_ovl,deltapci) ) // s'il ne l'est pas non plus pour la sequence target j'elimine
			{
				//fprintf(stderr,"3) %lld => %d, %hd, max3=%hd, d=%hd\n",i,p_ovl->seqid,p_ovl->pci,p_seq->maxpci3,deltapci);
				p_ovl->len=0;
			}
		}
	}
}

// je verifie que le hit reciproque passe aussi le seuil sur l'identite
// si ce n'est pas le cas il est supprime
int CheckReciprocalIdentity(seq_t *p_seqrecip,int seqid,ovlwith_t *p_ovl,short deltapci)
{
	if ( p_seqrecip->status == ST_AVOID )
		return(FALSE);
	
	if ( CheckReciprocalIdentityOneEnd(p_seqrecip->ovl3,p_ovl->pci,deltapci,seqid,p_seqrecip->maxpci3) || 
		 CheckReciprocalIdentityOneEnd(p_seqrecip->ovl5,p_ovl->pci,deltapci,seqid,p_seqrecip->maxpci5) )
		return(TRUE);
	return(FALSE);
}

int CheckReciprocalIdentityOneEnd(UT_array *ovl,short pci,short deltapci,unsigned long long seqid,short maxpci)
{
ovlwith_t *p_ovl;
short tolerence=(maxpci-deltapci); // depend de l'extremite

	for(p_ovl=(ovlwith_t*)utarray_front(ovl); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(ovl,p_ovl)) 
	{	
		// le PCI100_DELTA represente une tolerence de 0.1 % identite (si 10) car les pci ont ete *100
		// c'est au cas ou le calcul ne soit pas pile exact
		if ( p_ovl->seqid == seqid && abs(pci-p_ovl->pci) < PCI100_DELTA ) // il peut y avoir plusieurs hsp par paire
		{
			//fprintf(stderr,"RECIPROCAL3 %d, %hd, max3=%hd, d=%hd\n",seqid,p_ovlrecip->pci,p_seqrecip->maxpci3,deltapci);
			if ( p_ovl->len == 0 || (p_ovl->pci < tolerence) )
			{
				p_ovl->len = 0;
				return(FALSE);
			}
			else
				return(TRUE);
		}
	}
	return(FALSE);
}

//Supprime les hits redondants sur la meme region de la query et de la target
//Priorite au hit le plus long (a partir du moment ou le seuil d'identite est passe tout doit etre bon)
//Je ne tiens pas compte du brin au cas ou il y aurait des trucs bizarres
//000014884 005382741 -6042 96.07 0 0 6058 6331 0 7408 13450 13450 overlap
//000014884 005382741 -6221 96.11 0 0 6234 6331 0 7229 13450 13450 overlap
void TagRedundantOverlaps(seq_t **a_seq,int maxid)
{
unsigned long long i;
seq_t *p_seq;

	Date("TagRedundantHits");
	for(i=0;i<(maxid+1);i++)
	{
		p_seq = (*a_seq+i);
		TagRedundantOverlapsOneEnd(a_seq,p_seq->ovl3);
		TagRedundantOverlapsOneEnd(a_seq,p_seq->ovl5);
	}
	CompressListOfOverlaps(a_seq,maxid,FALSE);
}

void TagRedundantOverlapsOneEnd(seq_t **a_seq,UT_array *ovl)
{
ovlwith_t *p_ovl;
ovlwith_t *p_ovl2;
	
	utarray_sort(ovl,SortOnDecreasingOvlLen);
	for(p_ovl=(ovlwith_t*)utarray_front(ovl); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(ovl,p_ovl)) 
	{	
		if ( (*a_seq+p_ovl->seqid)->status != ST_AVOID && p_ovl->len )
		{
			// j'eteins les successeurs de longueur inferieures (j'ai trie par longueur decroissante)
			// je commence sur le suivant du courant
			p_ovl2=p_ovl;
			p_ovl2=(ovlwith_t*)utarray_next(ovl,p_ovl2); 
			for( ; p_ovl2!=NULL; p_ovl2=(ovlwith_t*)utarray_next(ovl,p_ovl2)) 
			{
				if ( p_ovl2->seqid == p_ovl->seqid )
				{
					//fprintf(stderr,"%d RED: %d > %d\n",p_ovl2->seqid,p_ovl->len,p_ovl2->len);
					p_ovl2->len=0;
				}
			}
		}
	}
}

int RemoveDoubleLinked(seq_t **a_seq,int maxid)
{
unsigned long long i;
seq_t *p_seq;
ovlwith_t *p_ovl3;
ovlwith_t *p_ovl5;

	Date("RemoveDoubleLinked (keeping longest one)");

	for(i=0;i<maxid;i++)
	{
		p_seq = (*a_seq+i);
		if ( p_seq->status == ST_AVOID || p_seq->len == 0 )
			continue;
		
		for(p_ovl3=(ovlwith_t*)utarray_front(p_seq->ovl3); p_ovl3!=NULL; p_ovl3=(ovlwith_t*)utarray_next(p_seq->ovl3,p_ovl3)) 
		{	
			for(p_ovl5=(ovlwith_t*)utarray_front(p_seq->ovl5); p_ovl5!=NULL; p_ovl5=(ovlwith_t*)utarray_next(p_seq->ovl5,p_ovl5)) 
			{	
				if ( p_ovl3->seqid == p_ovl5->seqid &&  p_ovl3->len && p_ovl5->len )
				{
					if ( p_ovl3->len < p_ovl5->len )
						p_ovl3->len=0;
					else 
						p_ovl5->len=0;
				}
			}
		}
	}
}

// (re)calcul de la longueur des ailes pour toutes les sequences
// L'aile c'est la longueur apporte par la target, cette longueur ne peut pas etre plus longue que l'overlap pour eviter les ailes non suffisament ancrees
void InitWings(seq_t **a_seq,int maxid,int minwing)
{
unsigned long long i;
seq_t *p_seq;

	Date("InitWings");
	for(i=0;i<(maxid+1);i++)
	{
		p_seq = (*a_seq+i);
		if ( p_seq->status == ST_AVOID )
			continue;
		if ( p_seq->len == 0 )
			continue;
		p_seq->maxwing3=InitWingsOneEnd(a_seq,p_seq->ovl3);
		p_seq->maxwing5=InitWingsOneEnd(a_seq,p_seq->ovl5);
	}
}

int InitWingsOneEnd(seq_t **a_seq,UT_array *ovl)
{
int max=0;
ovlwith_t *p_ovl;

	for(p_ovl=(ovlwith_t*)utarray_front(ovl); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(ovl,p_ovl)) 
	{	
		if ( (*a_seq+p_ovl->seqid)->status != ST_AVOID )
			max=Max(Min(p_ovl->wing,p_ovl->len),max);
	}
	return(max);
}

// Tant qu'au moins une sequence est eliminee
// TagSeq taggue ST_AVOID toutes les sequences pour lequelles on n'a pas d'ovl >= a minwing (donc celles avec une liste d'ovl vide)
// RecomputeWings recalcul des wing sans les voisins taggues ST_AVOID
void IterativeCheckOfWings(seq_t **a_seq,int maxid, int minwing)
{
unsigned long long i=1;
seq_t *p_seq;
	
	Date("IterativeCheckOfWings");
	int not_done=TRUE;
	while ( not_done )
	{
		not_done = KeepSequencesAboveMinwing(a_seq,maxid,minwing);
		fprintf(stderr,"CheckOverlaps iteration=%lld, #edits=%d\n",i++,not_done);
		//fprintf(stderr,"DEBUG\n");
		//not_done = 0;
		if ( not_done ) 
			InitWings(a_seq,maxid,minwing);
	}
	CompressListOfOverlaps(a_seq,maxid,FALSE);
}

// tague ST_AVOID les sequences qui ne passent pas le seuil de minwing
// tague ST_KEEP celles qui le passent
int KeepSequencesAboveMinwing(seq_t **a_seq,int maxid,int minwing)
{
unsigned long long i;
seq_t *p_seq;

	int edit=0;
	for(i=0;i<(maxid+1);i++)
	{
		p_seq = (*a_seq+i);
		if ( p_seq->len && p_seq->status != ST_AVOID)
		{
			if ( p_seq->maxwing5 < minwing || p_seq->maxwing3 < minwing )
			{
				p_seq->status=ST_AVOID;
				edit++;
			}
			else
				p_seq->status=ST_KEEP;
		}
	}
	return edit;
}

// remove secondary links not linked to the best one (largest overlap)
int ValidateOverlaps(seq_t **a_seq,int maxid,seqsortportance_t **a_seqportance,int nbseqok)
{
unsigned long long i;
unsigned int seqid;
seq_t *p_seq;
ovlwith_t *p_ovl;
ovlwith_t *p_ovl2;
int found;
int best;

	Date("ValidateOverlaps");

	for(i=0;i<nbseqok;i++)
	{
		seqid = (*a_seqportance+i)->seqid;
		p_seq = (*a_seq+seqid);
		
		if ( p_seq->status == ST_AVOID )
			continue;
		
		// il faut que je verifie que les successeurs sont aussi voisins de ceux qui ont un plus grand ovl
		// mais le plus grand a peut etre ete desactive par une sequence precendente a plus grande portance
		ValidateOverlapsOneEnd(a_seq,p_seq->ovl3,seqid,"3");
		ValidateOverlapsOneEnd(a_seq,p_seq->ovl5,seqid,"5");
	}
	CompressListOfOverlaps(a_seq,maxid,TRUE);
}

// prerequis: ovl est trie par taille decroissante
void ValidateOverlapsOneEnd(seq_t **a_seq,UT_array *ovl,int seqid,char str[250])
{
int best = FALSE;
ovlwith_t *p_ovl;
ovlwith_t *p_ovlbest=NULL;

	utarray_sort(ovl,SortOnDecreasingOvlLen);
	// identification du best 
	// le best overlap est le premier dont la longueur n'est pas nulle (il peut y avoir desactivation par des lectures a plus grande portance)
	for(p_ovl=(ovlwith_t*)utarray_front(ovl); p_ovl!=NULL && p_ovlbest == NULL; p_ovl=(ovlwith_t*)utarray_next(ovl,p_ovl)) 
	{	
		if ( p_ovl->len !=  0 && p_ovl->selected != -1 )
		{
			p_ovlbest=p_ovl;
			best=TRUE;
		}
	}
	
	// les overlap moins bons doivent chevaucher le meilleur
	for(p_ovl=(ovlwith_t*)utarray_front(ovl); p_ovl!=NULL && p_ovlbest != NULL ; p_ovl=(ovlwith_t*)utarray_next(ovl,p_ovl)) 
	{	
		if ( p_ovl->len == 0 )
			continue;
		// TODO: 1: propager la selection au reciproque ? FAIT
		//       2: ne tester que si je ne suis pas deja selectionne, FAIT
		// ALT:  tester si le reciproque est deja selectionne, si oui je prend la selection
		
		if ( p_ovl->selected == 0 )
			p_ovl->selected = ( best || IsReciprocal((*a_seq+p_ovlbest->seqid),p_ovl->seqid) ) ? 1 : -1;
		best=FALSE;
		fprintf(stderr,"%s: %i => %i (best=%d), selected=%d, len=%d\n", str, seqid, p_ovl->seqid, p_ovlbest->seqid, p_ovl->selected,p_ovl->len);
		if ( p_ovl->selected == -1 )
		{
			// desactivation du reciproque
			// DesactivateOneOverlap((*a_seq+p_ovl->seqid),seqid);
			// le souci c'est que le reciproque m'a peut etre deja valide comme successeurs (peut etre sur la base d'un meilleur best)
			p_ovl->len=0;
		}
		else
		{
			SelectReciprocalOverlap((*a_seq+p_ovl->seqid),seqid);
		}
	}
}


// les ovl que j'ai supprimes ont ete precedement taggue avec une len=0
// ici je supprime tous les ovl de longueur 0
int CompressListOfOverlaps(seq_t **a_seq,int maxid,int selection)
{
unsigned long long i;
seq_t *p_seq;

	Date("CompressListOfOverlaps");
	int wing=0;
	for(i=0;i<(maxid+1);i++)
	{
		p_seq = (*a_seq+i);
		if ( p_seq->len == 0 )
			continue;
		if ( p_seq->status == ST_AVOID )
		{
			utarray_clear(p_seq->ovl3);
			utarray_clear(p_seq->ovl5);
			continue;
		}
		CompressListOfOverlapsOneEnd(a_seq,p_seq->ovl3,selection); 
		CompressListOfOverlapsOneEnd(a_seq,p_seq->ovl5,selection); 
	}
	int nbseqok=0;
	for(i=0;i<(maxid+1);i++)
	{
		p_seq = (*a_seq+i);
		if ( p_seq->len == 0 || utarray_len(p_seq->ovl3) == 0 || utarray_len(p_seq->ovl5) == 0 || p_seq->status == ST_AVOID )
			p_seq->status = ST_AVOID;
		else
			nbseqok++;
	}
	if ( nbseqok == 0 )
	{
		fprintf(stderr,"CompressListOfOverlaps/No sequence passes the cutoffs, I stop\n");
		exit(0);
	}
	else
		fprintf(stderr,"# sequences=%d\n",nbseqok);
	return(nbseqok);
}


void CompressListOfOverlapsOneEnd(seq_t **a_seq,UT_array *ovl,int selection)
{
UT_array*   ovltmp;
utarray_new(ovltmp,&ovlwith_t_icd);
ovlwith_t *p_ovl;
	
	for(p_ovl=(ovlwith_t*)utarray_front(ovl); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(ovl,p_ovl)) 
	{	
		if ( (*a_seq+p_ovl->seqid)->status != ST_AVOID && p_ovl->len > 0 && ( ! selection ||  p_ovl->selected == 1 ) )
		{
			utarray_push_back(ovltmp,p_ovl);
		}
	}
	utarray_clear(ovl);
	if ( utarray_len(ovltmp) > 0 )
	{
		utarray_concat(ovl,ovltmp);
		utarray_clear(ovltmp);
	}
}


// supprime les liens qui n'ont pas de reciproque
void CleanupNoReciprocal(seq_t **a_seq,int maxid)
{
unsigned long long i;
seq_t *p_seq;

	Date("CleanupNoReciprocal");
	for(i=0;i<maxid;i++)
	{
		p_seq = (*a_seq+i);
		if ( p_seq->len == 0 )
			continue;
		if( p_seq->status == ST_AVOID )
			continue;
		
		CleanupNoReciprocalOneEnd(a_seq,p_seq->ovl3,i);
		CleanupNoReciprocalOneEnd(a_seq,p_seq->ovl5,i);
	}
	CompressListOfOverlaps(a_seq,maxid,FALSE);
}

void CleanupNoReciprocalOneEnd(seq_t **a_seq,UT_array *ovl,unsigned long long seqid)
{
ovlwith_t *p_ovl;

	for(p_ovl=(ovlwith_t*)utarray_front(ovl); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(ovl,p_ovl)) 
		if ( ! IsReciprocal((*a_seq+p_ovl->seqid),seqid))
		{
			p_ovl->len=0;
			p_ovl->selected=-1;
		}
}

int IsReciprocal(seq_t *p_seqrecip,unsigned long long seqid)
{
ovlwith_t *p_ovlrecip;

	if ( p_seqrecip->status == ST_AVOID )
		return(FALSE);
	
	if ( HasOverlapWithOneEnd(p_seqrecip->ovl3,seqid) || HasOverlapWithOneEnd(p_seqrecip->ovl5,seqid) )
		return(TRUE);
	return(FALSE);
}

int HasOverlapWithOneEnd(UT_array *ovl,int seqid)
{
ovlwith_t *p_ovl;

	for(p_ovl=(ovlwith_t*)utarray_front(ovl); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(ovl,p_ovl)) 
	{	
		if ( p_ovl->seqid == seqid )
			return(TRUE);
	}
	return(FALSE);
}

void SelectReciprocalOverlap(seq_t *p_seq,int seqid)
{
ovlwith_t *p_ovl;

	if ( p_seq->status != ST_AVOID )
	{
		for(p_ovl=(ovlwith_t*)utarray_front(p_seq->ovl3); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(p_seq->ovl3,p_ovl)) 
		{	
			if ( p_ovl->seqid == seqid )
				p_ovl->selected=1;
		}
		for(p_ovl=(ovlwith_t*)utarray_front(p_seq->ovl5); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(p_seq->ovl5,p_ovl)) 
		{	
			if ( p_ovl->seqid == seqid )
				p_ovl->selected=1;
		}
	}
}

void DumpAnchorRegions(char *out,UT_array **a_spe_regions,unsigned long long maxid)
{
unsigned long long i;
region_t *p_region;
UT_array* ip_region;

	fprintf(stderr,"Dumping specific regions/anchors in %s\n",out);
	FILE *f_out  = GetStreamOut(out);
	for(i=0;i<(maxid+1);i++)
	{
		ip_region = a_spe_regions[i];
		for(p_region=(region_t*)utarray_front(ip_region); p_region!=NULL; p_region=(region_t*)utarray_next(ip_region,p_region)) 
				fprintf(f_out,"%09lld\t%d\t%d\n",i,p_region->start,p_region->end);
	}
	CloseStream(out,f_out);
}


// chargement des regions specificiques  de chaque lectures (bed)
void LoadAnchorRegions(char *speregions,UT_array **a_spe_regions)
{
char line[MAXL+1];

	FILE *f_in  = GetStreamIn(speregions);
//Liste des regions specifiques sur les lectures
//000061417 0   1000
	int query,start,end;
	region_t region;
	UT_array* p_region;
	while(fgets(line,MAXL,f_in) != NULL)
	{
		sscanf(line,"%d %d %d",&query,&start,&end);
//		fprintf(stderr,"%d, %d, %d\n",query,start,end);
		p_region = (*a_spe_regions+query);
		region.start=start;
		region.end=end;
		utarray_push_back(a_spe_regions[query],&region);
	}
	CloseStream(speregions,f_in);
}

void ComputeAnchorRegions(sequence_t **a_sequences,unsigned long long nb_seq,seq_t **a_seq,unsigned long long maxid,UT_array **a_spe_regions,unsigned long long genomesize,char *ovlin, float slicex)
{
unsigned long long tot_reads_nt = 0;
int i;

	int minlen    = 200;
	int minreplen = 200;
	int trimlen   = 50;

	// 1) get the total number of nt in database
	int maxlen = 0;
	int len=0;
	for(i=0;i<nb_seq;i++)
	{
		len=strlen((*a_sequences+i)->seq);
		tot_reads_nt += len;
		if ( len > maxlen )
			maxlen=len;
	}
	
	fprintf(stderr,"# of nt : %lld\n",tot_reads_nt);
	fprintf(stderr,"expected coverage: %f\n",(float)(tot_reads_nt/genomesize));
	// number of slices to expect slicex x per slice
	int n_slices = ceil((float)(tot_reads_nt/genomesize/slicex));
	if (n_slices<=5 )
	{
		fprintf(stderr,"Warning: the # of slices must be > 5, from %d to 6\n",n_slices);
		n_slices=6;
	}
	fprintf(stderr,"# of slices: %d\n",n_slices);
	// 2) init randomly the slice_id for each sequence by targeting 1x per slice
	short a_prev[5]; // sequences with a "close" id in the same bin must be avoided (subreads of the same polymerase read in pacbio)
	                 // a_prev array store the last five slice_ids
	for(i=0;i<5;i++)
		a_prev[i]=-1;
	
	int *a_count_slices = (int *)malloc(sizeof(int)*(n_slices+1));
	for(i=0;i<=n_slices;i++)
		a_count_slices[i]=0;
	
	unsigned long long seqid;
	short slice;
	int j;
	srand(19081969); // 
	for(i=0;i<nb_seq;i++)
	{
		if ( (*a_sequences+i) == NULL || (*a_sequences+i)->seq == NULL )
			continue;
		sscanf((*a_sequences+i)->header,"%lld",&seqid); // in falcon format >00044444
		while (slice=(1+(rand()%n_slices)))
		{
			if ( slice!=a_prev[0] && slice!=a_prev[1] && slice!=a_prev[2] && slice!=a_prev[3] && slice != a_prev[4] )
				break;
		}
		(*a_seq+seqid)->slice_id=slice;
		(*a_seq+seqid)->len=strlen((*a_sequences+i)->seq);
		for(j=5;j>0;j--)
			a_prev[j]=a_prev[j-1];
		a_prev[0]=slice;
		a_count_slices[slice]++;
		/*
		fprintf(stderr,"%lld => %d\n",seqid,slice);
		for(j=0;j<5;j++)
			fprintf(stderr," %d ",a_prev[j]);
		fprintf(stderr,"\n");
		*/
	}
	/*
	for(i=1;i<=n_slices;i++)
		fprintf(stderr,"slice %03d: %d sequences\n",i,a_count_slices[i]);
	*/
	LoadOverlaps(ovlin,a_seq,0,minreplen,0,a_spe_regions,ANCHOR_INIT,1);
	
	char *a_seqstr = (char *)malloc(maxlen+1);
	seq_t *p_seq;
	char *idx;
	int s,istrmin,istrmax;
	ovlwith_t *p_ovl;
	region_t region;
	region_t *p_region;
	UT_array* ip_region;
	for(i=0;i<(maxid+1);i++)
	{
		p_seq = (*a_seq+i);
		if ( p_seq->status == ST_AVOID )
			continue;
		if ( p_seq->len == 0 )
			continue;
		for(j=0;j<p_seq->len;j++) // by defaut the whole sequence is specific
			a_seqstr[j]='1';
		
		// overlap are masked 
		for(p_ovl=(ovlwith_t*)utarray_front(p_seq->ovl3); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(p_seq->ovl3,p_ovl)) 
			for(j=p_ovl->qstart;j<(p_ovl->qstart+p_ovl->len-1);j++)
				a_seqstr[j]='\0';
		for(p_ovl=(ovlwith_t*)utarray_front(p_seq->ovl5); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(p_seq->ovl5,p_ovl)) 
			for(j=p_ovl->qstart;j<(p_ovl->qstart+p_ovl->len-1);j++)
				a_seqstr[j]='\0';
		a_seqstr[p_seq->len]='\0';
		
		idx=a_seqstr;
		for(s=0;s<p_seq->len;s++)
		{
			if ( strlen(idx+s) == 0 ) 
				continue;

			istrmin = s;
			istrmax = istrmin+strlen(idx+s)-1;
			s+=(strlen(idx+s)-1);
			region.start=istrmin+trimlen;
			region.end=istrmax-trimlen;
			if ( region.end - region.start > minlen )
				utarray_push_back(a_spe_regions[i],&region);
		}
	}
	free(a_seqstr);
	
	// as the same datastruct is used here it must be done again before the loading of specific regions
	InitDataStruct(a_seq,a_spe_regions,maxid,0);
}

//cherche un ovl dans la liste des regions specifiques
int FindAnchor(UT_array **a_spe_regions,int query,int start,int end)
{
	region_t region;
	UT_array* ip_region;
	region_t* p_region;
	ip_region = a_spe_regions[query];
	if (utarray_len(ip_region)==0)
		return 0;
	for(p_region=(region_t*)utarray_front(ip_region); p_region!=NULL; p_region=(region_t*)utarray_next(ip_region,p_region)) 
	{
	//	fprintf(stderr,"TEST %d %d %d <= %d %d\n",query,start,end, p_region->start, p_region->end);
		if ( end >= p_region->start && start <= p_region->end )
			return 1;
	}
	return 0;
}

// j'execute la methode a la toute fin du processus, si les deux sequences sont valides elles ont deja passees tous les seuils pas besoin de verifier
// supprime les sequences completement incluses dans des plus longues
void RemoveContained(char *ovlcontainer,seq_t **a_seq,unsigned long long maxid,int minwing)
{
char line[MAXL+1];
	int nb_removed=0;
	int query,target;
	int   ovllen,qlen,tlen;
	float pcif;
	short qstrand,tstrand;
	int qstart,qend,tstart,tend;
	seq_t *p_seq;
	ovlwith_t *p_ovl;
	unsigned long long i;
	char tag[100];
	int maxwingonquery;
	
	Date("RemoveContained");
	FILE *f_in  = GetStreamIn(ovlcontainer);
//000000000 003744301 -3739 98.28 0 0 3723 3723 0 2245 5984 19032 contained
//000000000 003983908 -2311 95.89 0 602 2912 3723 0 0 2311 2311 contains
	while(fgets(line,MAXL,f_in) != NULL)
	{
		sscanf(line,"%d %d %d %f %hd %d %d %d %hd %d %d %d %s",&query,&target,&ovllen,&pcif,&qstrand,&qstart,&qend,&qlen,&tstrand,&tstart,&tend,&tlen,tag);
		//tag[strlen(tag)-1]='\0'; 
		p_seq=NULL;
		if ( strcmp(tag,"contained") == 0     && (*a_seq+target)->status == ST_KEEP )
			p_seq = (*a_seq+query);
		else if ( strcmp(tag,"contains") == 0 && (*a_seq+query)->status == ST_KEEP )
			p_seq = (*a_seq+target);
		else
			continue; // skip when the file contains all type of overlaps
		if ( p_seq != NULL && p_seq->status != ST_AVOID )
		{
			nb_removed++;
			p_seq->status = ST_AVOID;
		}
	}
	CloseStream(ovlcontainer,f_in);
	fprintf(stderr,"# contained sequences (removed): %d\n",nb_removed);

	Date("RemoveNearlyContained");
	for(i=0;i<(maxid+1);i++)
	{
		p_seq = (*a_seq+i);
		if ( p_seq->len == 0 )
			continue;
		if ( p_seq->status == ST_AVOID )
			continue;
		
		maxwingonquery=0;
		for(p_ovl=(ovlwith_t*)utarray_front(p_seq->ovl3); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(p_seq->ovl3,p_ovl)) 
		{	
			if ( p_ovl->len )
				maxwingonquery=Max(maxwingonquery,(p_seq->seqlen-p_ovl->len));
		}
		for(p_ovl=(ovlwith_t*)utarray_front(p_seq->ovl5); p_ovl!=NULL; p_ovl=(ovlwith_t*)utarray_next(p_seq->ovl5,p_ovl)) 
		{	
			if ( p_ovl->len )
				maxwingonquery=Max(maxwingonquery,(p_seq->seqlen-p_ovl->len));
		}
		if (maxwingonquery < minwing )
		{
			nb_removed++;
			p_seq->status = ST_AVOID;
		}
			
	}
	fprintf(stderr,"# contained+nearly contained sequences (removed): %d\n",nb_removed);
}

// charge les overlaps au dessus d'un seuil de pci et de longueur
// en option on peut eliminer ceux qui ne chevauchement pas une region specifique
void LoadOverlaps(char *ovlin,seq_t **a_seq,float minpci,int minovl,int minseqlen,UT_array **a_spe_regions,int mode,int spemode)
{
char line[MAXL+1];
	
	Date("LoadOverlaps");
#if 0 
	char buffslice[BUFFER_SIZE];
	sprintf(buffslice,"%s.%d.same_slice",ovlin,getpid());
	FILE *f_sameslice=NULL;
	if ( mode == ANCHOR_INIT )
		f_sameslice  = GetStreamOut(buffslice);
#endif
	fprintf(stderr,"Mode = %d\n",mode);
	FILE *f_in  = GetStreamIn(ovlin);
//000061417 000061418 -14150 98.48 0 0 14080 14083 1 0 14150 19538 overlap
//dans ce n'est pas une demi matrice, pas besoin d'inverser
//on dirait que c'est du 0-based 1-based
	int query,target;
	int   ovllen,qlen,tlen;
	float pcif;
	short qstrand,tstrand;
	int qstart,qend,tstart,tend;
	ovlwith_t ovl;
	seq_t *p_seq;
	region_t region;
	UT_array* p_region;
	int okcpt=1;
	char tag[100];
	long long cptloaded=0;
	int problematic_format=0;
	while(fgets(line,MAXL,f_in) != NULL)
	{
		sscanf(line,"%d %d %d %f %hd %d %d %d %hd %d %d %d %s",&query,&target,&ovllen,&pcif,&qstrand,&qstart,&qend,&qlen,&tstrand,&tstart,&tend,&tlen,tag);
		if ( mode == ANCHOR_INIT ) // when detecting repeated regions, all is required inside the same slice_id
		{
			if ( (*a_seq+query)->slice_id != (*a_seq+target)->slice_id )
				continue;
		}
		else 
		{
			if ( qlen < minseqlen || tlen < minseqlen )
				continue;
			if ( strstr(tag,"contain") != NULL )
				continue;
		}
		
		if ( mode == ANCHOR_LOADED )
		{
			okcpt=0;
			okcpt = FindAnchor(a_spe_regions,query,qstart,qend);
			if ( ! okcpt || spemode == 2 )
			{
				okcpt += FindAnchor(a_spe_regions,target,tstart,tend);
			}
			if ( okcpt < spemode )
				continue;
		}
//		fprintf(stderr,"%d\n",okcpt);
		ovl.len=qend-qstart;
		ovl.qstart=qstart;
		ovl.wing=tlen-(tend-tstart);
		if ( mode == ANCHOR_INIT )
		{
			if ( ovl.len < minovl )
				continue;
		}
		else
		{
			if ( pcif < minpci || ovl.len < minovl || ovl.wing < MINWINGLEN )
				continue;
		}
		cptloaded++;
		ovl.pci=(short)(pcif*100);
		ovl.seqid=target;
		if ( ovl.wing > ovl.len ) // l'aile ne peut pas etre superieure  la longueur du chevauchement pour ne pas donner trop d'importance a des ovl trop tenus
			ovl.wing=ovl.len;
		ovl.selected=0;
		ovl.tstrand=tstrand;
		p_seq = (*a_seq+query);
		p_seq->seqlen=qlen;
		assert(qstrand==0); // VERIF dans fichier complet
		// pour savoir de quel cote de la query est l'overlap, si le hit va jusqu'a la fin/qlen c'est 3' et s'il commence a 0 c'est 5'
		if ( qend == qlen )
		{
			if ( ovl.pci > p_seq->maxpci3 )
				p_seq->maxpci3 = ovl.pci;
			utarray_push_back(p_seq->ovl3,&ovl);
		}
		else if ( qstart == 0 )
		{
			if ( ovl.pci > p_seq->maxpci5 )
				p_seq->maxpci5 = ovl.pci;
			utarray_push_back(p_seq->ovl5,&ovl);
		}
		else
		{
			if ( mode != ANCHOR_INIT )
			{
				//002497916 002497917 -14648 99.34 0 2 14641 14647 1 0 14648 14648 overlap
				//ce sont des faux contains, du a de la redondance presque stricte
				//j'ai l'impression que la target est ok, je vais eliminer la courante qui pose souci
				p_seq->status = ST_AVOID;
				problematic_format++;
				//fprintf(stderr,"Warning: unexpected format: %s\n",line);
			}
			else
			{
			 	// arbitrary in the 5' list, no matter in this mode (contains/contained reads)
				utarray_push_back(p_seq->ovl5,&ovl);
			}	
		}
		if ( p_seq->len == 0 )
			p_seq->len = qlen;
#if 0
		if ( f_sameslice != NULL )
			fprintf(f_sameslice,"%s",line);
#endif
	}
	CloseStream(ovlin,f_in);
	fprintf(stderr,"# unexpected format: %d\n",problematic_format);
	fprintf(stderr,"# ovl loaded: %lld\n",cptloaded);
#if 0
	if ( mode == ANCHOR_INIT )
		CloseStream(buffslice,f_sameslice);
#endif
}


// Dump des ovl des sequences non tagguees ST_AVOID [selectionnes]
void DumpOverlaps(char *ovlin,seq_t **a_seq,char *ovlout,float minpci,int minovl,float deltapcif,int mode)
{
char line[MAXL+1];
short deltapci=(short)(deltapcif*100);

	FILE *f_in   = GetStreamIn(ovlin);
	FILE *f_out  = GetStreamOut(ovlout);
	int query,target;
	int   ovllen,qlen,tlen;
	float pcif;
	short qstrand,tstrand;
	int qstart,qend,tstart,tend;
	ovlwith_t ovl;
	ovlwith_t *p_ovl;
	seq_t *p_seq;
	char tag[100];
	short pci;
	while(fgets(line,MAXL,f_in) != NULL)
	{
		sscanf(line,"%d %d %d %f %hd %d %d %d %hd %d %d %d %s",&query,&target,&ovllen,&pcif,&qstrand,&qstart,&qend,&qlen,&tstrand,&tstart,&tend,&tlen,tag);
		if ( strcmp(tag,"contain") == 0 )
			continue;
		ovl.len=qend-qstart;			
		if ( pcif < minpci || ovl.len < minovl )
			continue;
		p_seq = (*a_seq+query);
		// je rajoute le controle sur ST_AVOID car c'est le tag principal
		if ( p_seq->status == ST_AVOID || (*a_seq+target)->status == ST_AVOID )
			continue;
		ovl.pci=(short)(pcif*100);
		if ( qend == qlen )
			DumpOverlapsOneEnd(f_out,line,a_seq,&ovl,target,p_seq->ovl3,mode);
		else if ( qstart == 0 )
			DumpOverlapsOneEnd(f_out,line,a_seq,&ovl,target,p_seq->ovl5,mode);
		/*
		else
			fprintf(stderr,"Warning: unexpected format: %s",line);
		*/
	}
	CloseStream(ovlin,f_in);
	CloseStream(ovlout,f_out);
	fprintf(stderr,"%s dumped\n",ovlout);
}

void DumpOverlapsOneEnd(FILE *f_out,char *line,seq_t **a_seq,ovlwith_t *read_ovl,int target,UT_array *ovl,int mode)
{
int	done=FALSE;
ovlwith_t *p_ovl;

	for(p_ovl=(ovlwith_t*)utarray_front(ovl); p_ovl!=NULL && ! done; p_ovl=(ovlwith_t*)utarray_next(ovl,p_ovl)) 
	{	
		if ( (*a_seq+p_ovl->seqid)->status != ST_AVOID && p_ovl->seqid == target 
			  && (p_ovl->selected == 1 ||mode==ALL_OVL) 
			  && p_ovl->len == read_ovl->len  // ceux qui je ne veux pas ont la len=0
			  && p_ovl->pci == read_ovl->pci ) 
			// je dois verifier que je suis sur le bon hsp de la paire, il peut y en avoir plusieurs
		{
			fprintf(f_out,"%s",line);
			done=TRUE;
		}
	}
}

void InitPortance(seqsortportance_t **a_seqportance,int nbseqok,seq_t **a_seq,int maxid)
{
unsigned long long i,j;

	if ( *a_seqportance==NULL )
		free(*a_seqportance);
	seqsortportance_t *tmp=(seqsortportance_t *)malloc((nbseqok)*sizeof(seqsortportance_t));
	*a_seqportance=tmp;
	for(i=0,j=0;i<(maxid+1);i++)
	{
		if ( (*a_seq+i)->len == 0 || (*a_seq+i)->status == ST_AVOID )
			continue;
		(*a_seqportance+j)->seqid=i;
		(*a_seqportance+j)->portance=((*a_seq+i)->len+(*a_seq+i)->maxwing3+(*a_seq+i)->maxwing5);
		j++;
	}
	assert(j==nbseqok);
	qsort (*a_seqportance, nbseqok, sizeof(seqsortportance_t), SortPortanceDecreasing);
/*
	for(j=0;j<nbseqok;j++)
		fprintf(stderr,"%lld, %d, %d\n",j,(*a_seqportance+j)->seqid,(*a_seqportance+j)->portance);
*/
}
	


int SortOnCovDecreasing(const void *a,const void*b) 
{
	ovlwith_t const *pa=a;
	ovlwith_t const *pb=b;
	
	if( pb->pci == pa->pci )
		return (pb->wing - pa->wing );
    return pb->pci - pa->pci;
}

int SortOnDecreasingOvlLen(const void *a,const void*b) 
{
	ovlwith_t const *pa=a;
	ovlwith_t const *pb=b;
	
	if( pb->len == pa->len )
		return (pb->pci - pa->pci );
    return pb->len - pa->len;
}

int SortOnDecreasingPortance(const void *a,const void*b) 
{
	ovlwith_t const *pa=a;
	ovlwith_t const *pb=b;
	
	if( (pb->len+pb->wing) == (pa->len+pa->wing) )
		return (pb->pci - pa->pci );
    return (pb->len+pb->wing) - (pa->len+pa->wing);
}

int SortPortanceDecreasing (void const *a, void const *b)
{
   seqsortportance_t const *pa = a;
   seqsortportance_t const *pb = b;

   return (pb->portance - pa->portance);
}


// Je calcule la moyenne de couverture
void GetMeanCov(seq_t **a_seq,int maxid,double *meancov,int *maxcov,int print)
{
int i;
seq_t *p_seq;
ovlwith_t *p_ovl;
int count=0;
int nbcount=0;
int c3,c5;

	*maxcov=0;
	for(i=0;i<maxid;i++)
	{
		p_seq = (*a_seq+i);
		if ( p_seq->len == 0 )
			continue;
		if( p_seq->status == ST_AVOID )
			continue;
		c3=utarray_len(p_seq->ovl3);
		c5=utarray_len(p_seq->ovl5);
		if ( c3 && c5 )
		{
			(*maxcov)=Max(*maxcov,c3);
			(*maxcov)=Max(*maxcov,c5);
			count+=(c3+c5);
			nbcount+=2;
		}
	}
	*meancov=(double)count/(double)nbcount;
	if (print)
		fprintf(stderr,"mean cov=%.4lf, max cov=%d\n",*meancov,*maxcov);
}



void Usage (char *argv[])
{
/*
 * --minseedendcov    integer    [%d]\n\
 * --penalty_fact   float        [%.2f] NOT USED keep only the best 2*meancov/penalty_fact best overlaps for highly connected ends (>2*meancov)\n\
 */
fprintf(stderr,"\
\n\
Usage: til-r --src fastafile --ovlin filename --ovlout filename\n\
\n\
Mandatory\n\
--src        fastafile (Falcon formatted fasta file: preads4falcon.fasta)\n\
--ovlin      overlap file (Falcon formatted overlap file: preads.ovl)\n\
--ovlout     filtered overlap file (Falcon formatted overlap file)\n\
\n\
Optional\n\
--minwing    integer          [%d]\n\
--minovl     integer          [%d]\n\
--minseqlen  integer          [%d]\n\
--minpci     float            [%.2f]\n\
--deltapci   float            [%.2f]\n\
\n\
Repeated/anchor regions can be read from a file\n\
--specificregions file        tabulated file (id start end)\n\
or computed based on the provided genomesize (warning: based on randomisation)\n\
--genomesize string           expected size in nucleotides (e.g: 120000000 of 120000[Kk] or 120[Mm] or 0.120[Gg])\n\
--spemode    integer          [%d] 2: query and target overlap, 1: Q or T overlaps\n\
\n\
",DEFAULT_PARAM_MINWING,DEFAULT_PARAM_MINOVL,DEFAULT_PARAM_MINSEQLEN,DEFAULT_PARAM_MINPCI,DEFAULT_PARAM_DELTAPCI,DEFAULT_PARAM_SPEMODE);
}

/*
--ncpus      integer          [%d]\n\
--dump-postspe                dump overlap overlapping specific regions
--dump-wings                  dump overlap post wings cleaning (la sequence doit avoir au moins une wing >= maxwing )
--dump-nocont                 dump overlap post contained cleaning
--only-rbh                    run rbh filter and stop
*/
